﻿Public Class frmMenu
    Private Sub ExecMyScriptCommand(ByVal ScriptCommand As String)
        askin.ExecScriptCommand(ScriptCommand, Me)
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menEnd.Click
        ExecMyScriptCommand("End()")
    End Sub

    Private Sub InfoStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menInfo.Click
        ExecMyScriptCommand("ShowInfo()")
    End Sub

    Private Sub AbspielenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menPlay.Click
        ExecMyScriptCommand("Play()")
    End Sub

    Private Sub StoppenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menStop.Click
        ExecMyScriptCommand("Stop()")
    End Sub

    Private Sub QuickplayStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menQuickplay.Click
        ExecMyScriptCommand("Quickplay()")
    End Sub

    Private Sub LeerenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menClearPlaylist.Click
        ExecMyScriptCommand("ClearPlaylist()")
    End Sub

    Private Sub MuteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menMuteToggle.Click
        ExecMyScriptCommand("Mute()") ' Mute() ohne Parameter bewirkt einen "Toggle"
    End Sub

    Private Sub Volume0StripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume0StripMenuItem.Click
        ExecMyScriptCommand("SetVolume(0)")
    End Sub

    Private Sub Volume1ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume1ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(10)")
    End Sub

    Private Sub Volume2ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume2ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(20)")
    End Sub

    Private Sub Volume3ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume3ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(30)")
    End Sub

    Private Sub Volume4ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume4ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(40)")
    End Sub

    Private Sub Volume5ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume5ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(50)")
    End Sub

    Private Sub Volume6ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume6ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(60)")
    End Sub

    Private Sub Volume7ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume7ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(70)")
    End Sub

    Private Sub Volume8ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume8ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(80)")
    End Sub

    Private Sub Volume9ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume9ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(90)")
    End Sub

    Private Sub Volume10ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Volume10ToolStripMenuItem.Click
        ExecMyScriptCommand("SetVolume(100)")
    End Sub

    Private Sub QuickplayURLToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menQuickplayURL.Click
        ExecMyScriptCommand("QuickplayURL()")
    End Sub

    Private Sub ShowPlaylistToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menShowPlaylist.Click
        ExecMyScriptCommand("ShowPlaylistEditor()")
    End Sub

    Private Sub LoadToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menLoadPlaylist.Click
        ExecMyScriptCommand("LoadPlaylist()")
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menSavePlaylist.Click
        ExecMyScriptCommand("SavePlaylist()")
    End Sub

    Private Sub OptionsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menSettings.Click
        ExecMyScriptCommand("ShowSettings()")
    End Sub

    Private Sub PauseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menPause.Click
        ExecMyScriptCommand("Pause()")
    End Sub

    Private Sub RepeatPlaylistToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menRepeatPlaylist.Click
        menRepeatPlaylist.Checked = (RepeatPlaylist Xor True) ' Toggle
        RepeatPlaylist = menRepeatPlaylist.Checked
    End Sub

    Private Sub RandomizeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menRandomize.Click
        menRandomize.Checked = (RandomMode Xor True) ' Toggle
        RandomMode = menRandomize.Checked
    End Sub

    Private Sub IntromodeStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menIntromode.Click
        menIntromode.Checked = (IntroMode Xor True) ' Toggle
        IntroMode = menIntromode.Checked
    End Sub

    Private Sub menPlayFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menPlayDir.Click
        ExecMyScriptCommand("QuickplayDir()")
    End Sub

    Private Sub menIncreaseVol_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menIncreaseVol.Click
        ExecMyScriptCommand("IncreaseVolume()")
    End Sub

    Private Sub menDecreaseVol_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menDecreaseVol.Click
        ExecMyScriptCommand("DecreaseVolume()")
    End Sub

    Private Sub menRepeatMedium_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menRepeatMedium.Click
        menRepeatMedium.Checked = (RepeatMedium Xor True) ' Toggle
        RepeatMedium = menRepeatMedium.Checked
    End Sub

    Private Sub menSkins_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menSkins.Click
        ExecMyScriptCommand("ShowSkins()")
    End Sub

    Private Sub menConsole_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menConsole.Click
        ExecMyScriptCommand("ShowConsole()")
    End Sub

    Private Sub Menu_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Menu.Opening
        menShowPlayer.Visible = CBool(frmAudia.WindowState = FormWindowState.Minimized)
    End Sub

    Private Sub menShowPlayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menShowPlayer.Click
        ExecMyScriptCommand("ShowPlayer()")
    End Sub

    Private Sub menArtistInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menShowArtistInfo.Click
        ExecMyScriptCommand("ShowInfoToCurrentArtist()")
    End Sub

    Private Sub menOpenPortable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menOpenPortable.Click
        Dim Portable As sPortable
        For Each Portable In Portables
            If Portable.Use Then
                Diagnostics.Process.Start(Portable.Drive)
            End If
        Next
    End Sub

    ' Kopiert die Medien der akt. Playliste auf einen portablen Datenträger
    Private Sub menCopyPlaylisteToPortable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menCopyPlaylisteToPortable.Click
        Dim Portable As sPortable

        For Each Portable In Portables
            If Portable.Use Then
                Dim FreeSpace As Long = GetFreeDriveSpace(Portable.Drive)  ' Angabe des freien Speicherplatz in Bytes

                Dim i As Integer
                Dim NeededSpace As Long = 0
                Dim HighestIndex As Integer = Playlist.colMediaIDs.Count - 1
                For i = 0 To Playlist.colMediaIDs.Count - 1
                    If Media(Playlist.colMediaIDs(i)).MediumType = eMediumTypes.eSoundfile Then ' Nur Sound-Mediendateien kopieren.
                        Dim file = New IO.FileInfo(Media(Playlist.colMediaIDs(i)).Filename)

                        NeededSpace += file.Length
                        If NeededSpace > FreeSpace Then
                            If i = 0 Then
                                MsgBox(Loc("Der folgende portable Datenträger bietet keinen freien Speicherplatz mehr. Es werden keine Mediendateien kopiert.") + vbCr + vbCr + Portable.Drive + vbCr + "(" + Portable.Name + ")", MsgBoxStyle.Exclamation, Loc("Fehler"))
                                GoTo NextPortable ' ggf. nächster Datenträger
                            Else
                                If MsgBox(Loc("Der folgende portable Datenträger bietet nur genug freien Speicherplatz für die ersten ") + " " + i.ToString + " " + Loc("Mediendateien") + "." + vbCr + vbCr + Portable.Drive + vbCr + "(" + Portable.Name + ")" + vbCr + vbCr + Loc("Sollen diese Mediendateien kopiert werden?"), MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, Loc("Fehler")) = MsgBoxResult.No Then
                                    If MsgBox(Loc("Der Kopiervorgang für diesen portablen Datenträger wird abgebrochen und stattdessen ggf. mit dem nächsten Datenträger fortgefahren."), MsgBoxStyle.Information + MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then Exit Sub
                                    GoTo NextPortable ' ggf. nächster Datenträger
                                Else ' wenn weiter gemacht werden soll: 
                                    HighestIndex = i - 1
                                    Exit For ' Schleife abbrechen
                                End If
                            End If
                        End If
                    End If
                Next

                For i = 0 To HighestIndex
                    If Media(Playlist.colMediaIDs(i)).MediumType = eMediumTypes.eSoundfile Then ' Nur Sound-Mediendateien kopieren.
                        Try
                            My.Computer.FileSystem.CopyFile(Media(Playlist.colMediaIDs(i)).Filename, Portable.Drive + GetPath(Media(Playlist.colMediaIDs(i)).Filename, True), FileIO.UIOption.AllDialogs, FileIO.UICancelOption.ThrowException)
                        Catch ex As OperationCanceledException
                            Exit Sub ' Der Benutzer hat den Kopiervorgang abgebrochen.
                        Catch ex As Exception
                            Log("Global", Loc("Fehler beim Kopieren einer Mediendatei auf einen portablen Datenträger."), True)
                        End Try
                    End If
                Next
            End If
NextPortable:
        Next
    End Sub

    Private Sub menBuyMusicOnline_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menBuyMusicOnline.Click
        ExecMyScriptCommand("GoToWeblink(" + Chr(34) + Loc(LinkMusicDownload) + Chr(34) + ")")
    End Sub

    Private Sub mentxtSearch_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles mentxtSearch.GotFocus
        mentxtSearch.Text = ""
    End Sub

    Private Sub mentxtSearch_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles mentxtSearch.KeyPress
        If e.KeyChar = vbCr Then
            ExecMyScriptCommand("SearchLibrary(" + Chr(34) + mentxtSearch.Text + Chr(34) + ")")
            mentxtSearch.SelectAll()
            frmPlaylist.Show()
        End If
    End Sub

    Private Sub mentxtSearch_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles mentxtSearch.LostFocus
        mentxtSearch.Text = "(" + Loc("Suchtext") + ")"
    End Sub

    Private Sub MediumInOrdnerAnzeigenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menShowMediumStoragePlace.Click
        ShowMediumStoragePlace()
    End Sub

    Private Sub AusPlaylisteEntfernenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menRemoveMedium.Click
        If Playlist.CurMediumIndex <> IsVoid Then ' Wenn ein Playlistenelement ausgewählt wurde, ...
            RemoveFromPlaylist_ByPosition(Playlist.CurMediumIndex + 1) ' ... dieses aus der Playliste entfernen. (+1, weil die Position, nicht der Index, gefordert ist.)
        End If
    End Sub

    Private Sub menMediumProperties_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menMediumProperties.Click
        ExecMyScriptCommand("ShowMediumProperties()")
    End Sub

    Private Sub menForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menForward.Click
        ExecMyScriptCommand("PlaylistForward()")
    End Sub

    Private Sub menBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menBack.Click
        ExecMyScriptCommand("PlaylistBack()")
    End Sub

    Private Sub menHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menHelp.Click
        ExecMyScriptCommand("ShowHelp()")
    End Sub

    Private Sub menSongtext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menShowSongtext.Click
        ExecMyScriptCommand("ShowSongtext()")
    End Sub

    Private Sub menStepBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menStepBack.Click
        ExecMyScriptCommand("StepBack()")
    End Sub

    Private Sub menStepForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menStepForward.Click
        ExecMyScriptCommand("StepForward()")
    End Sub

    Private Sub menAddFavorit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menAddFavorit.Click
        ExecMyScriptCommand("AddCurToFavorits()")
    End Sub

    Private Sub menManageFavorits_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menManageFavorits.Click
        ExecMyScriptCommand("ShowFavorits()")
    End Sub

    Private Sub menMenuPortables_EnabledChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles menMenuPortables.EnabledChanged
        SeperatorPortables.Visible = menMenuPortables.Enabled
        menCopyPlaylisteToPortable.Visible = menMenuPortables.Enabled
        menOpenPortable.Visible = menMenuPortables.Enabled
    End Sub

    ' Durchsucht einen Ordner, den der Benutzer per Dialog auswählen kann, nach neuen Mediendateien und fügt diese der Medienbilibothek hinzu.
    Private Sub FestplatteNachMedienDurchsuchenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FestplatteNachMedienDurchsuchenToolStripMenuItem.Click
        Dim DirPath As String

        Dim FolderDialog As New System.Windows.Forms.FolderBrowserDialog()
        FolderDialog.ShowNewFolderButton = False
        FolderDialog.Description = Loc("Bitte wählen Sie einen Ordner aus, der nach neuen Medien durchsucht werden soll. Unterordner werden berücksichtigt.")

        FolderDialog.ShowDialog()
        If FolderDialog.SelectedPath = "" Then Exit Sub
        DirPath = FolderDialog.SelectedPath

        Try
            Dim LastCount As Integer, NewCount As Integer = 0

            ShowNotify(Loc("Analysiere Ordner..."))
            Debug.Print("start searching directory: " + Now.ToString + ":" + Now.Millisecond.ToString)
            For Each Filename In My.Computer.FileSystem.GetFiles(DirPath, FileIO.SearchOption.SearchAllSubDirectories)
                If IsMediaFile(Filename) Then
                    LastCount = Media.Count
                    LoadMedium(Filename) ' Zur virtuellen Playliste hinzufügen - aber nur bekannte Formate!
                    If Media.Count > LastCount Then NewCount += 1
                End If
            Next
            ShowNotify(Loc("Analyse abgeschlossen." + vbCr))
            'ShowNotify(Loc("Analyse abgeschlossen." + vbCr + NewCount.ToString + Loc(" Medien gefunden.")))
            Debug.Print("end searching directory: " + Now.ToString + ":" + Now.Millisecond.ToString)
        Catch ex As Exception
            Log(, Loc("Fehler beim Durchsuchen eines Ordners.") + " (" + DirPath + ")", True)
        End Try
    End Sub
End Class