﻿Imports System.Windows.Forms

Public Class frmSettings

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        AlwaysTopMost = chkTopMost.Checked
        WindowOpacity = tbOpacity.Value / 100 ' muss aus %-Wert umgerechnet werden

        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub frmSettings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim tn1 As TreeNode, tn2 As TreeNode

        tn1 = tvCats.Nodes.Add(Loc("Allgemeine Einstellungen"))
        tn1.Tag = "1"
        lblSelectCat.Text = Loc("Bitte wählen Sie eine Kategorie aus." + vbCr + vbCr + "Hinweis: Einige Einstellungen werden möglicherweise erst nach einem Neustart des Programms angewendet.")
        tvCats.SelectedNode = tn1
        gbCCat.Text = tn1.Text


        tn2 = tn1.Nodes.Add(Loc("Erscheinungsbild"))
        tn2.Tag = "2"
        lblOpacity.Text = Loc(lblOpacity.Text)
        tbOpacity.Value = WindowOpacity * 100 ' muss in %-Wert umgerechnet werden
        chkTopMost.Text = Loc(chkTopMost.Text)
        chkTopMost.Checked = AlwaysTopMost

        tn1.ExpandAll()
    End Sub

    Private Sub tvCats_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles tvCats.Click
        Dim tn As TreeNode
        tn = tvCats.GetNodeAt(tvCats.PointToClient(tvCats.MousePosition()))
        If Not IsNothing(tn) Then
            tvCats.SelectedNode = tn
            For Each Control In gbCCat.Controls
                If Control.tag = "panel" Then
                    Control.Visible = (Control.Name = "pan" + tn.Tag.ToString)
                End If
            Next
            gbCCat.Text = tn.Text
        End If
    End Sub
End Class
