﻿Public Class frmAudia
    Dim DragMode As Boolean
    Dim DragStartX As Long
    Dim DragStartY As Long

    Private Sub frmAudia_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop
        Dim FileList() As String
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            FileList = CType(e.Data.GetData(DataFormats.FileDrop), String())
            QuickplayFilelist(FileList)
        End If
    End Sub

    Private Sub frmAudia_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Link
        End If
    End Sub

    Private Sub frmAudia_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        acore.Shutdown()
    End Sub

    Private Sub frmAudia_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Visible = False

        acore.Start()

        Me.Location = frmAudiaStartupLocation

        If LoadSkin() = False Then
            If Skinname.ToUpper = DefaultSkin.ToUpper Then
                MsgBox(Loc("Der Standard-Skin wurde beschädigt. Bitte installieren Sie das Programm neu."))
            Else
                If MsgBox(Loc("Ausgewählter Skin konnte nicht geladen werden. Stattdessen Standard-Skin laden?"), MsgBoxStyle.YesNo + MsgBoxStyle.Exclamation, Loc("Fehler")) = MsgBoxResult.Yes Then
                    LoadSkin(DefaultSkin)
                Else
                    acore.Shutdown()
                End If
            End If
        End If
        Me.Opacity = WindowOpacity
        Me.TopMost = AlwaysTopMost
        Me.Visible = True
    End Sub

    Private Sub frmAudia_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseClick
        If e.Button = Windows.Forms.MouseButtons.Left Then SkinEvent_Click(sender, e)
        If e.Button = Windows.Forms.MouseButtons.Right Then frmMenu.Menu.Show(sender, New Point(e.X, e.Y))
    End Sub

    Private Sub frmAudia_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            DragMode = True
            DragStartX = MousePosition.X - Me.Location.X
            DragStartY = MousePosition.Y - Me.Location.Y
        End If
    End Sub

    Private Sub frmAudia_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If DragMode = True Then
            Me.Location = New Point(MousePosition.X - DragStartX, MousePosition.Y - DragStartY)
        End If
    End Sub

    Private Sub frmAudia_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        DragMode = False
    End Sub

    Private Sub ExecMyScriptCommand(ByVal ScriptCommand As String)
        askin.ExecScriptCommand(ScriptCommand, Me)
    End Sub
End Class

