﻿Public Class frmConsole
    Dim LastUpdateTime As Date = Now

    Private Sub frmConsole_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        TabControl.TabPages(2).Text = SettingsFile
        Try
            txtSettingsFile.Text = My.Computer.FileSystem.ReadAllText(AppPath + "\" + SettingsFile)
        Catch ex As Exception
            ' keine Reaktion, der Fehler wird ggf. beim eig. Laden der Settings-Datei bemerkt und behandelt.
        End Try
    End Sub

    Private Sub txtCommand_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtCommand.KeyPress
        If e.KeyChar = vbCr Then
            lstCommandLog.Items.Add(txtCommand.Text)
            ExecScriptCommand(txtCommand.Text)
        End If
    End Sub

    Private Sub lstCommandLog_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstCommandLog.Click
        txtCommand.Text = lstCommandLog.SelectedItem.ToString
    End Sub

    Private Sub butClearCommandLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butClearCommandLog.Click
        lstCommandLog.Items.Clear()
    End Sub

    Private Sub butClearBlobalLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butClearBlobalLog.Click
        txtGlobalLog.Clear()
    End Sub

    Public Sub UpdateSkript()
        Dim i As Integer
        For i = 0 To SkinCode.GetLength(0) - 1
            txtScript.Text += askin.SkinCode(i) + vbCrLf
        Next
    End Sub

    Public Sub UpdateGlobalObs()
        If TabControl.SelectedIndex = 0 Then
            If (Now - LastUpdateTime).TotalSeconds >= 1 Then
                LastUpdateTime = Now

                txtGlobalObs.Text = ""
                txtGlobalObs.Text += "GlobalTicks=" + GlobalTicks.ToString + vbCrLf
                txtGlobalObs.Text += vbCrLf
                txtGlobalObs.Text += "Media.Count=" + Media.Count.ToString + vbCrLf
                txtGlobalObs.Text += "Playlist.colMediaIDs.Count=" + Playlist.colMediaIDs.Count.ToString + vbCrLf
                txtGlobalObs.Text += "Playlist.CurMediumID=" + Playlist.CurMediumID.ToString + vbCrLf
                txtGlobalObs.Text += "Playlist.CurMediumIndex=" + Playlist.CurMediumIndex.ToString + vbCrLf
                If Playlist.CurMediumID <> IsVoid Then
                    txtGlobalObs.Text += "Media(Playlist.CurMediumID).Filename=" + Media(Playlist.CurMediumID).Filename.ToString + vbCrLf
                    txtGlobalObs.Text += "Media(Playlist.CurMediumID).MediumType=" + Media(Playlist.CurMediumID).MediumType.ToString + vbCrLf
                    txtGlobalObs.Text += "Media(Playlist.CurMediumID).PlayLen=" + Media(Playlist.CurMediumID).PlayLen.ToString + vbCrLf
                    txtGlobalObs.Text += "HasTag(Media(Playlist.CurMediumID).Filename)=" + CBool(Media(Playlist.CurMediumID).Title <> "").ToString + vbCrLf
                    txtGlobalObs.Text += "GetPlayPos()=" + GetPlayPos().ToString + vbCrLf
                End If
                txtGlobalObs.Text += "UserVolume=" + UserVolume.ToString + vbCrLf
                txtGlobalObs.Text += vbCrLf
                txtGlobalObs.Text += "Skinname=" + Skinname + vbCrLf
                txtGlobalObs.Text += "CurWindowName=" + CurWindowName + vbCrLf
                txtGlobalObs.Text += "SkinModuls.Count=" + SkinModuls.Count.ToString + vbCrLf
                txtGlobalObs.Text += "SkinObjects.Count=" + SkinObjects.Count.ToString + vbCrLf
                txtGlobalObs.Text += vbCrLf
                txtGlobalObs.Text += "CommandLineArgs.Count=" + My.Application.CommandLineArgs.Count.ToString + vbCrLf
            End If
        End If
    End Sub
End Class